package router

import (
	"github.com/gin-gonic/gin"
	"integrity-checkin/middleware"
	"integrity-checkin/pkg/app"
	"integrity-checkin/service"
)

func Setup(engine *gin.Engine) {
	engine.Use(middleware.Cors())
	user := engine.Group("/user")
	{
		hub := service.ExUserService
		// 测试方法，获取signed jwt
		user.POST("/login", app.HandlerFunc(hub.Login))
		user.Use(middleware.JWT(1))
		user.GET("/me", app.HandlerFunc(hub.Me))
		user.POST("/set_type", app.HandlerFunc(hub.SetType))
	}
	checkin := engine.Group("/checkin")
	{
		hub := service.ExCheckinService
		checkin.Use(middleware.JWT(1))
		checkin.GET("/list_activities", app.HandlerFunc(hub.ListActivities))
		checkin.POST("/submit", app.HandlerFunc(hub.Submit))
		checkin.GET("/get_my_activities_today", app.HandlerFunc(hub.GetMyActivitiesToday))
		checkin.POST("/set_status", middleware.JWT(2), app.HandlerFunc(hub.SetStatus))
		checkin.GET("/get_user_activity", middleware.JWT(2), app.HandlerFunc(hub.GetUserActivity))
		checkin.GET("/list_user_activities", middleware.JWT(2), app.HandlerFunc(hub.ListUserActivities))
	}
}
